/* AMX Mod X
*   Name Bans
*
* (c) Copyright 2005-2006 by VEN
*
* This file is provided as is (no warranties)
*/

/*
:
	    ().

	:
		 ,  amx_mode   2 (     ).
		amx_mode      addons\amxmodx\configs\amxx.cfg

:
	amx_nban <name>|<#userid> <[._]> -        #userid   
	amx_nunban <name> -   
	amx_nbanlist -  ,         

	:
		amx_nban "Shadow Man" 3 -   Shadow Man  3 
		amx_nban #37 1.5 -     #userid 37  1.5 ()  (90 )
		amx_nban Cheater 0 -   Cheater     ( 30 )
		amx_nunban "Shadow Man" -   Shadow Man

	:
		       ADMIN_BAN ( "d")
	
:
	MAX_BANS 64 -     (     )
	CMD_ACCESS_LEVEL ADMIN_BAN -     (. scripting/include/amxconst.inc  )
	PERM_BAN_ACCESS_LEVEL ADMIN_RCON -         1 

	FILE_LOG[] = "namebans.log" - ,    (, ,  ban/unban)
	FILE_CFG[] = "namebans.ini" - ,   

	:
		    "namebans.ini", ..        !


	1.   , .. namebans.amxx,  addons\amxmodx\configs\plugins.ini ,  .
	2.     .


	1.  namebans.amxx  addons\amxmodx\configs\plugins.ini        .
	2.     ,    .


	#amxmodx @ irc.efnet-ru.org ( irc://irc.efnet-ru.org/amxmodx ) - IRC     AMX Mod X
	http://amxmodx.ucoz.ru/forum -     AMX Mod X (  )
	http://wiki.amxmodx.org/index.php/Category:Russian -    AMX Mod X (  )
	http://amxmodx.ucoz.ru/forum/8-117-1 -    AMX Mod X ,     ..
*/

#include <amxmodx>
#include <amxmisc>

// OPTIONS BELOW

#define CMD_ACCESS_LEVEL ADMIN_BAN
#define PERM_BAN_ACCESS_LEVEL ADMIN_RCON

#define MAX_BANS 64

new FILE_LOG[] = "namebans.log" // in amxmodx/logs folder
new FILE_CFG[] = "namebans.ini" // in amxmodx/configs folder

// OPTIONS ABOVE

new g_config[64]
new g_name[MAX_BANS][32]
new g_remove_ban_at[MAX_BANS]
new g_bans

public plugin_init() {
	register_plugin("Name Bans","0.1.1","VEN")
	register_concmd("amx_nban","cmd_nameban",CMD_ACCESS_LEVEL,"<name>|<#userid> <minutes[.minutefraction]>")
	register_concmd("amx_nunban","cmd_nameunban",CMD_ACCESS_LEVEL,"<name>")
	register_concmd("amx_nbanlist","cmd_namebanlist",CMD_ACCESS_LEVEL)
}

public plugin_cfg() {
	get_configsdir(g_config,63)
	format(g_config,63,"%s/%s",g_config,FILE_CFG)
	load_settings()
}

public plugin_end() {
	save_settings()
}

public client_authorized(id) {
	new name[32]
	get_user_name(id,name,31)
	new systime=get_systime()
	for (new i=0; i<g_bans; ++i) {
		if (equal(name,g_name[i]) && g_remove_ban_at[i]>systime) {
			server_cmd("kick #%d ^"You has been banned from this server. Connect after %.1f min^"",get_user_userid(id),(g_remove_ban_at[i]-systime)/60.0)
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_CONTINUE
}

public cmd_nameban(id,level,cid) {
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new target[32]
	read_argv(1,target,31)
	new tid=cmd_target(id,target,1)
	if (!tid)
		return PLUGIN_HANDLED
	new minutes[8]
	read_argv(2,minutes,7)
	new Float:f_minutes=floatstr(minutes)
	if (f_minutes<0) {
		console_print(id,"[AMXX] Wrong second parameter!")
		return PLUGIN_HANDLED
	}
	new tname[32]
	get_user_name(tid,tname,31)
	new systime=get_systime()
	new bantime=floatround(f_minutes*60)
	if (!(get_user_flags(id)&PERM_BAN_ACCESS_LEVEL)) {
		if (!bantime) {
			console_print(id,"[AMXX] Wrong second parameter!")
			return PLUGIN_HANDLED
		}
		else if (bantime>3600)
			bantime=3600
	}
	new remove_ban_at=systime+bantime
	if (!bantime)
		remove_ban_at=1999999999
	for (new i=0; i<g_bans; ++i) {
		if (equal(tname,g_name[i])) {
			if (g_remove_ban_at[i]>systime) {
				console_print(id,"[AMXX] %s already banned [until %d]",tname,g_remove_ban_at[i])
				return PLUGIN_HANDLED
			}
			g_remove_ban_at[i]=remove_ban_at
			ban_name(id,tid,remove_ban_at)
			return PLUGIN_HANDLED
		}
	}
	new pos=-1
	for (new i=0; i<g_bans; ++i) {
		if (g_remove_ban_at[i]<systime) {
			pos=i
			break
		}
	}
	if (pos==-1) {
		if (g_bans==MAX_BANS) {
			console_print(id,"[AMXX] Error: ban list is full!")
			log_to_file(FILE_LOG,"Error: Defined value ^"MAX BANS^" has been reached!")
			return PLUGIN_HANDLED
		}
		pos=g_bans
		g_bans++
	}
	g_name[pos]=tname
	g_remove_ban_at[pos]=remove_ban_at
	ban_name(id,tid,remove_ban_at)
	return PLUGIN_HANDLED
}

public ban_name(id,tid,remove_ban_at) {
	new name[32],tname[32]
	get_user_name(id,name,31)
	get_user_name(tid,tname,31)
	new Float:fbantime=(remove_ban_at-get_systime())/60.0
	log_to_file(FILE_LOG,"^"%s^" ban and kick ^"%s^" [%.1f min]",name,tname,fbantime)
	switch (get_cvar_num("amx_show_activity")) {
		case 2: client_print(0,print_chat,"ADMIN %s: ban %s [%.1f min]",name,tname,fbantime)
		case 1: client_print(0,print_chat,"ADMIN: ban %s [%.1f min]",tname,fbantime)
	} 
	server_cmd("kick #%d ^"You has been banned from this server. Connect after %.1f min^"",get_user_userid(tid),fbantime)
}

public cmd_nameunban(id,level,cid) {
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new target[32]
	read_argv(1,target,31)
	for (new i=0; i<g_bans; ++i) {
		if (equal(target,g_name[i])) {
			if (g_remove_ban_at[i]<get_systime()) {
				console_print(id,"[AMXX] %s not banned!",target)
				return PLUGIN_HANDLED
			}
			g_remove_ban_at[i]=-1
			new name[32]
			get_user_name(id,name,31)
			log_to_file(FILE_LOG,"^"%s^" unban ^"%s^"",name,target)
			switch (get_cvar_num("amx_show_activity")) {
				case 2: client_print(0,print_chat,"ADMIN %s: unban %s",name,target)
				case 1: client_print(0,print_chat,"ADMIN: unban %s",target)
			} 
			return PLUGIN_HANDLED
		}
	}
	console_print(id,"[AMXX] %s not found in ban list!",target)
	return PLUGIN_HANDLED
}

public cmd_namebanlist(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	new count,systime=get_systime()
	for (new i=0; i<g_bans; ++i) {
		if (g_remove_ban_at[i]>systime) {
			console_print(id," %-33.31s %.1f",g_name[i],(g_remove_ban_at[i]-systime)/60.0)
			count++
		}
	}
	if (!count)
	console_print(id,"[AMXX] Ban list is empty")
	return PLUGIN_HANDLED
}

public load_settings() {
	if (!file_exists(g_config)) {
		return PLUGIN_CONTINUE
	}
	new systime=get_systime()
	new string[128],line,len
	while (read_file(g_config,line++,string,127,len)) {
		if (g_bans==MAX_BANS) {
			log_to_file(FILE_LOG,"Warning: In process of reading file ^"%s^" defined value ^"MAX BANS^" has been reached",g_config)
			return PLUGIN_CONTINUE
		}
		if (string[0]==';' || !len)
			continue
		new remove_ban_at[16]
		new a=parse(string,g_name[g_bans],31,remove_ban_at,15)
		g_remove_ban_at[g_bans]=str_to_num(remove_ban_at)
		if (a>=2 && g_remove_ban_at[g_bans]>systime)
			g_bans++
	}
	return PLUGIN_CONTINUE
}

public save_settings() {
	if (file_exists(g_config))
		delete_file(g_config)
	if (!write_file(g_config,"; Generated by Name Bans Plugin. Do not modify!")) {
		log_to_file(FILE_LOG,"Error: Couldn't write to file ^"%s^"!",g_config)
		return PLUGIN_CONTINUE
	}
	new text[64]
	format(text,63,"; %-33.4s %s","Name","RemoveBanAt")
	write_file(g_config,text)
	new systime=get_systime()
	for (new i=0; i<g_bans; ++i) {
		if (g_remove_ban_at[i]>systime) {
			format(text,63,"^"%s^"",g_name[i])
			format(text,63,"%-35.33s %d",text,g_remove_ban_at[i])
			write_file(g_config,text)
		}
	}
	return PLUGIN_CONTINUE
}
